#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <time.h>
#include <signal.h>

#include "sendchain.h"

PacketChain::PacketChain()
{
	head_ = new PacketInChain();
	
}

PacketChain::~PacketChain()
{
	PacketInChain *pic;	
	while(head_) {
		pic = head_->next_;
		delete head_;
		head_ = pic;
	}
}

void PacketChain::add_pkt(int type, int seq, double delay)
{
	assert(delay>=0);
	PacketInChain *pic = new PacketInChain(type, seq);
	PacketInChain *tmp_pic = head_->next_, *npic;
	double interval = delay;

	if(head_->next_ == NULL) {
		head_->next_ = pic;
		return;
	}
	
	while( tmp_pic != NULL ) {
		if(tmp_pic->interval_ < 0) {		// last one in the chain
			tmp_pic->next_ = pic;
			tmp_pic->interval_ = delay;
			return;
		}
		
		if(tmp_pic->interval_ > delay)
			break;
		else {
			delay -= tmp_pic->interval_;
			tmp_pic = tmp_pic->next_;
		}
	}
	pic->next_ = tmp_pic->next_;
	tmp_pic->next_ = pic;
	pic->interval_ = tmp_pic->interval_ - delay;
	tmp_pic->interval_ = delay;
	
	//printf("%g, %g\n", tmp_pic->interval_, pic->interval_);
}

PacketInChain *PacketChain::pop_pkt()
{
	PacketInChain *pic;
	if(head_->next_) {
		pic = head_->next_;
		head_->next_ = pic->next_;
		pic->next_ = NULL;
		return pic;
	}
	else
		return NULL;
}
