#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <sys/socket.h>
#include <time.h>
#include <signal.h>
#include <arpa/inet.h>
#include <netdb.h>

#include "libnet.h"
#include <pcap.h>
#include <pcap-bpf.h>

int main(int argc, char *argv[]) 
{
	char *device, errbuf[PCAP_ERRBUF_SIZE+64], *ptr; 
	char *data = new char[65536];
	pcap_t * p; 
	struct bpf_program fcode;
	//char *filter_string = "icmp or udp";
	char *filter_string = "icmp and ip host 199.77.194.5";
	bpf_u_int32 netmask = 0;
	struct pcap_pkthdr hdr, *phdr = &hdr;
	struct libnet_ethernet_hdr * eth;

	device = pcap_lookupdev(errbuf);
	//printf("device: %s\n", device);
	if( strcmp(device, "eth0") != 0 ) {
		fprintf(stderr, "pcap_lookupdev: Wrong device %s\n", device);
	}
	if( (p = pcap_open_live(device, 8000, 1, 1000, errbuf)) == NULL ) {
		fprintf(stderr, "Cannot open device %s for pcap: %s\n", device, errbuf);
		exit(-1);
	}
	
	if( pcap_compile(p, &fcode, filter_string, 0, netmask) == -1 ) {
		fprintf(stderr, "pcap_compile error: %s\n", pcap_geterr(p) );
		exit(-1);
	}
	if( pcap_setfilter(p, &fcode) == -1 ) {
		fprintf(stderr, "pcap_setfilter error: %s\n", pcap_geterr(p) );
		exit(-1);
	}

	if( pcap_setnonblock(p, 1, errbuf) == -1 ) {
		fprintf(stderr, "pcap_setnonblock error: %s\n", errbuf );
		exit(-1);
	}
	
	for(int i=0; i<2 ;i++ )
	{
		while((ptr = (char *)(pcap_next(p, &hdr))) == NULL) {
	//	while( pcap_next_ex(p, (struct pcap_pkthdr **)&phdr, (const unsigned char**)&data) == 0) {
			printf("waiting\n");
		};			
		eth = (struct libnet_ethernet_hdr *)ptr;
		printf("got a packet, type:%d\n", htons(eth->ether_type));
		printf("ip: %d\n", ETHERTYPE_IP);
	}
	return 0;
}

