#ifndef __UTILS__
#define __UTILS__

#include <sys/time.h>

#define HAVE_NANOSLEEP

#ifndef	MAXHOSTNAMELEN
#define MAXHOSTNAMELEN	256
#endif

/*
typedef int bool;
#define true	1
#define false	0
*/

/**********************************************************
 *	                                     Structures
 **********************************************************/

/* Host name and address list */
struct hostinfo {
	char *name;
	int n;
	u_int32_t *addrs;
	u_int32_t dist;		// distance in hop
};

/* Data section of the probe packet */
//struct outdata {
//	u_char seq;		/* sequence number of this packet */
//	u_char ttl;		/* ttl packet left with */
//	struct timeval tv __attribute__((packed)); /* time packet left */
//};

struct outdata {
	time_t time_id;
	
	u_char seq;		/* sequence number of this packet */
	u_char ttl;		/* ttl packet left with */
	struct timeval tv __attribute__((packed)); /* time packet left */
	
	char src[10];		/* real source name, limited to 10 bytes */
//	char dst[1];		/* real destination */
};


extern char *prog;

/**********************************************************
 *	                                      UtilityFunctions
 **********************************************************/

u_short in_cksum(register u_short *addr, register int len);
double deltaT(struct timeval *t1p, struct timeval *t2p);
int usleep(register u_int useconds);
int str2val(register const char *str, register const char *what, register int mi, register int ma);
void setsin(register struct sockaddr_in *sin, register u_int32_t addr);
void getaddr(register u_int32_t *ap, register char *hostname);
bool gethostaddr(char *hostname, struct sockaddr_in *sin);

void freehostinfo(register struct hostinfo *hi);
struct hostinfo *gethostinfo(register char *hostname);
void tvsub(register struct timeval *out, register struct timeval *in);
void tvadd(register struct timeval *out, register struct timeval *in);
char *inetname(struct in_addr in);
int truncate_string(char *line);		//	get rid of the last white characters, such as \r \n, space, \t

#endif
